'Programmed by Jon Kreuzer. 3DDS v1.5

'See the Sub <instructions> for instructions.
'The code has been speed optimized, but still it is recommended
'that you have at least a 386 16Mhz. You'll need a 486 for the objects
'that are more complex than a couple of squares. Basically, the faster your
'computer the more you can do with this program.
'Quick Basic (Used for the .EXE) will usually run this program twice as
'fast as Qbasic.
'==== 3D programming purely in Qbasic is impossible. It's just a little too
'==== slow a language for that kind of stuff, and it doesn't have the power
'==== over memory that C does. So instead of trying
'==== for a realistic feel, this program moves very simple wireframe
'==== models in 3D space. Like Virtual Boy.
DECLARE SUB template ()
DEFINT A, D, I, R-T, V'===Defines all variables beginning with one of these
           '===letters as integers. Defining integers speeds the program
           '===greatly, so define as many as possible.
DGLASSES = 0 '==0 For no 3D-GLASSES. Setting it to 1 will make the object
             '==3D with 3D glasses, but the program will run at about half
             '==the speed. VGAMODE needs to be 13 for 3D glasses.
VGAMODE = 12 '==VGAMODE 13 for SCREEN 13 and VGAMODE 12 for SCREEN 12
file$ = "ship2" '==Set file$ = to the filename of the shape you want to load.
                '="ship", "ship2", "ship3", "square", and "ship4" are included.
SCREEN VGAMODE
IF DGLASSES = 1 THEN DIM drealx(40): DIM drealx2(40): sep3d = 9'==sep3d is the separation of the
                                        '==images. 9 seems to work the best.
DIM SHARED st(50), st2(50), x(40), y(40), z(40), nx(40), ny(40), nz(40)
DIM SHARED tl, vn
DIM realx(40), realy(40), realx2(40), realy2(40)'==(real as in real screen coordinate, not
                               '==real number.)
IF VGAMODE = 13 THEN FOR i = 1 TO 30: PALETTE i, i * 2: NEXT i'==reds
IF VGAMODE = 13 AND DGLASSES = 1 THEN FOR i = 1 TO 30: PALETTE 30 + i, i * 65536 * 2: NEXT i'==blues
IF VGAMODE = 12 THEN FOR i = 1 TO 15: PALETTE i, i * 4: NEXT i'==reds
' Set color palette to reds to better get the feel of Virtual Boy
IF VGAMODE = 13 THEN SHADE = 19: lshadef = .3
IF VGAMODE = 12 THEN SHADE = 9: lshadef = .15 '==We have half the colors in 12 so
                                '==we need half the shading.
'lshadef=line shading factor. The higher it is the more dramatic the shading.
'======(If it's too high you'll get some wierd colors)
cdelay = 1'===The delay length between program cycles
zoom = 100: sd = 50: turnangle = 5
IF VGAMODE = 13 THEN dx = 160: dy = 100'==Center (0,0) at center of screen
IF VGAMODE = 12 THEN dx = 320: dy = 200'==Center (0,0) at center of screen
'======zoom-Zoom Factor,sd-Standing distance from point of rotation
'======dx-How far over horizontally 0,0 is on the screen
'======dy-How far over vertically 0,0 is on the screen
'======NOTE: If the standing distance[sd] is too small, and any point
'======rotates to more than [sd] you'll get some really wierd effects! (And errors!)
'======[turnangle]-Turn angle. How many degrees in each step of a turn.
'======A higher turn angle can help compensate for a slower computer.

'==========THIS IS THE END OF THE ALTERABLE VARIABLES==================
IF file$ <> "" THEN GOSUB loadobject ELSE GOSUB square   '==If no object is loaded, use the square

DIM LCOS(361): DIM LSIN(361) '=====Calculating Sine and Cosine take too long to
LOCATE 1, 1: PRINT "Computing"    'be in every loop, so here we precompute them.
FOR i = 1 TO 360
LCOS(i) = COS(i * 3.1415 / 180)   'This calculation converts degrees to radians because the SIN and COS functions take radians, and we want to work in degrees.
LSIN(i) = SIN(i * 3.1415 / 180)
NEXT i
LOCATE 1, 1: PRINT "         "

'================THIS IS THE MAIN PROGRAM LOOP==============================
again:
1 SELECT CASE a$'===The actual input for a$ is further along in the program.
CASE "7", "1": FOR d = 1 TO vn: nx(d) = x(d) * LCOS(angle) - y(d) * LSIN(angle): ny(d) = y(d) * LCOS(angle) + x(d) * LSIN(angle)'==Turn point around 0 Z-axis===
               x(d) = nx(d): y(d) = ny(d)'====Here we'll set the points to our newly calculated ones
               NEXT d
CASE "8", "2": FOR d = 1 TO vn: nz(d) = (z(d)) * LCOS(angle) + y(d) * LSIN(angle): ny(d) = y(d) * LCOS(angle) - (z(d)) * LSIN(angle)'==Turn point around 0 X-axis===
               y(d) = ny(d): z(d) = nz(d)
               NEXT d
CASE "6", "4": FOR d = 1 TO vn: nx(d) = x(d) * LCOS(angle) + z(d) * LSIN(angle): nz(d) = z(d) * LCOS(angle) - x(d) * LSIN(angle)'==Turn point around 0 X-axis====
              x(d) = nx(d): z(d) = nz(d)
              NEXT d
END SELECT
'====Save points so we can erase them later
FOR d = 1 TO vn
realy2(d) = realy(d): realx2(d) = realx(d): IF DGLASSES = 1 THEN drealx2(d) = drealx(d)
NEXT d
'=====Below, the screen coordinates are computed. The standing distance is
'=====first subtracted from z, then each coordinate  is divided by z, then
'=====they are multiplied by <zoom>(the zoom factor).
'=====Finally dx & dy are added.
FOR d = 1 TO vn: realx(d) = zoom * (nx(d) / (nz(d) - sd)) + dx
realy(d) = zoom * (ny(d) / (nz(d) - sd)) + dy
IF DGLASSES = 1 THEN drealx(d) = zoom * ((nx(d) + sep3d) / (nz(d) - sd)) + dx
NEXT d
'====Let's erase the box before we draw a new one
FOR i = 1 TO tl
LINE (realx2(st(i)), realy2(st(i)))-(realx2(st2(i)), realy2(st2(i))), 0
IF DGLASSES = 1 THEN LINE (drealx2(st(i)), realy2(st(i)))-(drealx2(st2(i)), realy2(st2(i))), 0
NEXT i
'========Render our shape on the screen
FOR i = 1 TO tl
LINE (realx(st(i)), realy(st(i)))-(realx(st2(i)), realy(st2(i))), SHADE - (-z(st(i)) * lshadef)'This last part computes the color of the line according to distance
IF DGLASSES = 1 THEN LINE (drealx(st(i)), realy(st(i)))-(drealx(st2(i)), realy(st2(i))), SHADE + 30 - (-z(st(i)) * lshadef)'Draw the blues
NEXT i
13 a$ = INKEY$: IF a$ = "" THEN a$ = last$'===Get input if there is no input
IF cdelay <> 0 THEN SOUND 32676, cdelay                       'then set a$ to last input (last$).
'===The delay is only necessary for quick computers feel free to change it or delete it.
SELECT CASE MID$(a$, 2)'===We don't want to make the user turn numlock on, so
CASE CHR$(80): a$ = "2"'===we convert the codes to the number characters we use.
CASE CHR$(72): a$ = "8"
CASE CHR$(71): a$ = "7"
CASE CHR$(79): a$ = "1"
CASE CHR$(77): a$ = "6"
CASE CHR$(75): a$ = "4"
CASE CHR$(81): a$ = "3"
CASE CHR$(73): a$ = "9"
CASE CHR$(31): BEEP: LOCATE 1, 1'====== <alt>+<s> saves object ========
                INPUT "Save Filename (without extension)?      ", file$
                IF file$ <> "" THEN GOSUB saveobject
                CLS : a$ = ""
CASE CHR$(38): BEEP '===== <alt>+<l> loads an object =======
                LOCATE 1, 1
                INPUT "Load Filename (without extension)?      ", file$
                IF file$ <> "" THEN GOSUB loadobject
                a$ = "": CLS
CASE CHR$(30): LOCATE 1, 1 '====<alt>+<a> enters a new turnangle=======
               INPUT "New turn angle (in degrees)?", turnangle
               a$ = "": CLS
CASE CHR$(33): LOCATE 1, 1 '====<alt>+<f> enters a new line shading factor==
               INPUT "New shading factor (.1-.5)?", lshadef
               a$ = "": CLS
CASE CHR$(32): LOCATE 1, 1 '====<alt>+<d> enters a new delay=======
               INPUT "delay (0-2)?", cdelay
               a$ = "": CLS
CASE CHR$(20): CLS : template
              a$ = ""'==<alt>+<t> copies the template into the current object==
CASE CHR$(16), CHR$(68): END'====The user can quit now with <alt>+<q> or <F10>
END SELECT
last$ = a$
IF a$ = CHR$(27) OR a$ = CHR$(17) THEN END'The user can also quit with <Esc> or <ctrl>+<q>
IF a$ = "6" OR a$ = "8" OR a$ = "7" THEN angle = 360 - turnangle'===8-rotate up,6-rotate right,7-rotate
IF a$ = "4" OR a$ = "2" OR a$ = "1" THEN angle = turnangle'4-rotate left,2 rotate down,1-rotate
IF a$ = "9" THEN zoom = zoom * 1.04 '===9 will zoom in
IF a$ = "3" THEN zoom = zoom * .97 '===3 will zoom out
GOTO again

'=====Here we have our predefined square.

square: vn = 8 ' ==We'll need 8 vertices for a square
d = 1: x(d) = 12: y(d) = -12: z(d) = 12'===Sets point #1's coordinates
d = 2: x(d) = -12: y(d) = -12: z(d) = 12
d = 3: x(d) = -12: y(d) = 12: z(d) = 12
d = 4: x(d) = 12: y(d) = 12: z(d) = 12
d = 5: x(d) = 12: y(d) = -12: z(d) = -12
d = 6: x(d) = -12: y(d) = -12: z(d) = -12
d = 7: x(d) = -12: y(d) = 12: z(d) = -12
d = 8: x(d) = 12: y(d) = 12: z(d) = -12
FOR d = 1 TO vn: nx(d) = x(d): ny(d) = y(d): nz(d) = z(d): NEXT d'==give
                                                '==value to new points
st(1) = 1: st2(1) = 2 '==Here we define the lines.
st(2) = 2: st2(2) = 3 '==st(1)=1:st2(1)=2 connects vertex one to vertex two.
st(3) = 3: st2(3) = 4: st(4) = 4: st2(4) = 1
st(5) = 5: st2(5) = 1: st(6) = 6: st2(6) = 2
st(7) = 7: st2(7) = 3: st(10) = 8: st2(10) = 4
st(9) = 8: st2(9) = 5: st(8) = 5: st2(8) = 6
st(11) = 6: st2(11) = 7: st(12) = 7: st2(12) = 8
tl = 12 '==We need 12 lines for the square
RETURN

'===========Save & Load
saveobject:
OPEN file$ + ".shp" FOR OUTPUT AS #1'We'll write the file in text format so
                        'that it can be edited with any text editor.
WRITE #1, vn
FOR i = 1 TO vn
WRITE #1, x(i), y(i), z(i)
NEXT i
WRITE #1, tl
FOR i = 1 TO tl
WRITE #1, st(i), st2(i)
NEXT i
CLOSE
RETURN

loadobject:
LOCATE 1, 1: PRINT "loading..."
OPEN file$ + ".shp" FOR INPUT AS #1 '==Loads file$. Automatically adds shape extension
INPUT #1, vn
FOR i = 1 TO vn
INPUT #1, x(i), y(i), z(i)
NEXT i
FOR d = 1 TO vn: nx(d) = x(d): ny(d) = y(d): nz(d) = z(d): NEXT d'==give value to new points
INPUT #1, tl
FOR i = 1 TO tl
INPUT #1, st(i), st2(i)
NEXT i
CLOSE
LOCATE 1, 1: PRINT "          "
RETURN

command: '==Interpret the command line entered after invoking this program
        '==(Only for the .exe file)
'===Quick Basic gives us command$
FOR count = 1 TO 18
IF UCASE$(MID$(COMMAND$, count, 1)) = "G" THEN DGLASSES = 1
IF UCASE$(MID$(COMMAND$, count, 1)) = "H" THEN VGAMODE = 12
IF UCASE$(MID$(COMMAND$, count, 2)) = "-F" THEN file$ = MID$(COMMAND$, count + 2, 8): count = 20
NEXT count
RETURN

SUB instructions
'Use numeric keypad to rotate and zoom in on the object. <alt><q> quits.
'<alt><l> will load a .shp file as the current object. (.shp as in shape)
'<alt><s> will save the current object as a .shp file. For saving
'shapes you have created.
'<alt><a> will change the turn angle. This can help compensate for slower
'computers
'<alt><f> will change the line shading factor.
'<alt><d> will change the delay.
'In the SUB <template> you are provided with a template and instructions
'for creating a 3D object out of vertexes and lines.
'<alt><t> will make the template the current object so you can see
'what it looks like.

'To use the 3DDS.EXE use the same commands in the program (except for
'<alt><t>). Use <h> to run in high resolution.
'Use <g> for 3D glasses. (Does not work in high resolution mode)
'Use <-f> then filename, to load a file. (Must be last)
'EX. <3DDS h -fship2>
END SUB

'=====This is a template for creating your own 3D objects========
SUB template
'==The coordinates of the vertices are based actual screen pixel coordinates
vn = 0 '== vn=number of vertices. (Number of the last d value you use)
d = 1: x(d) = 0: y(d) = 0: z(d) = 0'===Sets point #1's coordinates
                                   '=== x-horizontal y-vertical z-depth
d = 2: x(d) = 0: y(d) = 0: z(d) = 0'==Only use how many points you need for
d = 3: x(d) = 0: y(d) = 0: z(d) = 0'==your object.
d = 4: x(d) = 0: y(d) = 0: z(d) = 0'==0,0 is the center of the screen, and
d = 5: x(d) = 0: y(d) = 0: z(d) = 0'==also the point of rotation.
d = 6: x(d) = 0: y(d) = 0: z(d) = 0
d = 7: x(d) = 0: y(d) = 0: z(d) = 0
d = 8: x(d) = 0: y(d) = 0: z(d) = 0
d = 9: x(d) = 0: y(d) = 0: z(d) = 0
d = 10: x(d) = 0: y(d) = 0: z(d) = 0
d = 11: x(d) = 0: y(d) = 0: z(d) = 0
d = 12: x(d) = 0: y(d) = 0: z(d) = 0
d = 13: x(d) = 0: y(d) = 0: z(d) = 0
d = 14: x(d) = 0: y(d) = 0: z(d) = 0
d = 15: x(d) = 0: y(d) = 0: z(d) = 0
d = 16: x(d) = 0: y(d) = 0: z(d) = 0
d = 17: x(d) = 0: y(d) = 0: z(d) = 0
d = 18: x(d) = 0: y(d) = 0: z(d) = 0
d = 19: x(d) = 0: y(d) = 0: z(d) = 0
d = 20: x(d) = 0: y(d) = 0: z(d) = 0
FOR d = 1 TO vn: nx(d) = x(d): ny(d) = y(d): nz(d) = z(d): NEXT d'==give
'==value to new points. There is no need to edit these two lines.
st(1) = 0: st2(1) = 0 '==Here we define our lines. The vertex in element 1
st(2) = 0: st2(2) = 0 '==of st is connected by a line to element 1 of st2
st(3) = 0: st2(3) = 0 '==and so on for element 2 and up.
st(4) = 0: st2(4) = 0 '==ex. st(1)=1:st2(1)=2 connects vertex 1 to vertex 2
st(5) = 0: st2(5) = 0 '==Use however many elements you need.
st(6) = 0: st2(6) = 0 '==The only thing order matters for is the line shading
st(7) = 0: st2(7) = 0 '==Lines will be shaded from st vertex, not st2 vertex
st(8) = 0: st2(8) = 0
st(9) = 0: st2(9) = 0
st(10) = 0: st2(10) = 0
st(11) = 0: st2(11) = 0
st(12) = 0: st2(12) = 0
st(13) = 0: st2(13) = 0
st(14) = 0: st2(14) = 0
st(15) = 0: st2(15) = 0
st(16) = 0: st2(16) = 0
st(17) = 0: st2(17) = 0
st(18) = 0: st2(18) = 0
st(19) = 0: st2(19) = 0
st(20) = 0: st2(20) = 0
st(21) = 0: st2(21) = 0
st(22) = 0: st2(22) = 0
st(23) = 0: st2(23) = 0
st(24) = 0: st2(24) = 0
st(25) = 0: st2(25) = 0
st(26) = 0: st2(26) = 0
st(27) = 0: st2(27) = 0
st(28) = 0: st2(28) = 0
st(29) = 0: st2(29) = 0
st(30) = 0: st2(30) = 0
tl = 0 '=== tl=total lines. Set tl = to however many lines you have. (Number
       '=== of elements you give values to in st and st2.)
'===When your object looks how you want it, <alt>+<s> will save.
'===You should save before rotating because of possible distortion.
END SUB

